 # Версия 2.0.0 (2023.05.03)

Это обновление значительно повышает качество кода, унифицирует интерфейсы и упрощает дальнейшую разработку. Проведён масштабный рефакторинг всей кодовой базы (~5,5 тыс строк кода на момент начала работы).

Основные изменения в этом выпуске касаются парсера аргументов и API-клиента.

> ❗**ВАЖНО**  
> Версия 2.0.0 содержит обратно несовместимые изменения. Обязательно прочтите их список прежде чем обновляться.

## Добавлено

- Добавлена команда `twc config unset` обратная по смыслу команде `twc config set`, она позволяет удалить из конфигурации ранее заданный параметр.
- Для команды `twc config file` добавлен флаг `--locate`. Если он передан, то в файловом менеджере откроется директория с конфигом.
- Теперь приложение найдёт конфигурационный файл, если он называется `.twcrc.toml`, а не только `.twcrc`.
- Добавлена команда `twc server backup schedule` для управления расписанием и настройками автоматических бэкапов дисков. Это клон удалённой команды `twc server disk auto-backup`.
- В API-клиент добавлены методы Проектов для добавления ресурсов каждого типа. Ранее был реализован только универсальный метод `move_resource_to_project()`.
- Добавлен алиас `lsw` для субкоманды `twc server list-software`.
- В команды `twc server dash` и `twc server vnc` добавлена опция `--print` для печати ссылки вместо перехода по ней в веб-браузере.
- Улучшено логирование. HTTP-запросы и ответы теперь более удобочитаемы. Добавлена переменная окружения `TWC_LOG` для настройки параметров логгера. Сейчас доступен только один параметр — `log_response`. По умолчанию тело ответа не логируется чтобы не захламлять лог, но этой опцией логирование можно включить.

## Обратно совместимые изменения

- Библиотека [Click](https://click.palletsprojects.com/) заменена на библиотеку [Typer](https://typer.tiangolo.com/). Благодаря этому переходу:
    - Заработал вызов команды через интерпретатор. То есть теперь можно вызывать програму так: `python -m twc version`. С Click это не работало, хоть и ожидалось.
    - Теперь глобальные опции `--verbose`, `--config`, `--profile` можно писать как в начале команд, так и в конце. Ранее были проблемы с передачей контекста субкомандам, теперь они решены.
    - Появилась поддержка автодополнения команд для оболочки PowerShell.
    - В Click пришлось писать сразу два разных костыля для поддержки алиасов команд. Сейчас есть элегантное решение под Typer :).
    - Удалён костыль для вызова группы команд (без него нельзя было вызвать `twc config`). Эта задача решается Typer нативно.
    - Удалён костыль для создания взаимоисключающих опций Click, вместо этого теперь используется обычный оператор if.
- Изменены описания некоторых параметров CLI.
- Улучшены все тексты ошибок, теперь они более подробные и более явно указывают на проблему.
- Глобально задействован модуль typing. Изменены аннотации типов (type-hints) для всех функций, классов и их методов. Теперь они соответствуют документации API и точнее отражают суть.

## ❗Обратно несовместимые изменения в CLI
 
- Изменён ситаксис команды `twc server set-boot-mode`, новый синтаксис: `set-boot-mode SERVER_ID... MODE`.
- Изменён ситаксис команды `twc server set-nat-mode`, новый синтаксис: `set-nat-mode SERVER_ID... MODE`.
- Команда `twc server set-property` переименована в `twc server set`.
- Команда `twc server logs` переименована в `twc server history`.
- Изменён синтаксис команды `twc server ip add`. Новый синтаксис: `add [OPTIONS] SERVER_ID`.
- Команда `twc server ip set-ptr` заменена на `twc server ip set`, новый синтаксис: `set --ptr POINTER IP_ADDRESS`.
- Изменён синтаксис команды `twc server disk add`. Новый синтаксис: `add --size SIZE SERVER_ID`.
- Удалена команда `twc server disk auto-backup`. Вместо неё используйте `twc server backup schedule`, синтаксис и опции команды никак не отличаются от старых.
- Команда `twc server backup set-property` переименована в `twc server backup set`.
- Изменён синтаксис команды `twc ssh-key add`, новый синтаксис: `add SSH_KEY_ID... SERVER_ID`.
- Команда `twc image set-property` переименована в `twc image set`.
- Команда `twc project set-property` переименована в `twc project set`.
- Изменём синтаксис команды `twc project resource move`, новый синтаксис: `move --[resource-type] [resource_id] PROJECT_ID`. Для каждого типа ресурса добавлена своя опция, например `--bucket`, `--server` и т.д.

## ❗Обратно несовместимые изменения в API-клиенте

- Переименованы методы для работы с публичными IP-адресами серверов: `get_ips_by_server_id()` -> `get_ips()`, `add_ip_addr()` -> `add_ip()`, `delete_ip_addr()` -> `delete_ip()`, `update_ip_addr()` -> `update_ip()`. Также в этих функциях изменено имя аргумента `ip_addr` на `ip`.
- Удалены все старые исключения, полный список и код новых исключений в файле [exceptions.py](../../twc/api/exceptions.py).
- Теперь в случае ошибки API генерируется исключение класса `TimewebCloudException` в котором содержатся данные запроса и ответа, а также отдельно ключи из JSON, отправляемые API в случае ошибок. Итого получается такой набор: `request (<PreparedRequest>)`, `response (<Response>)`, `status_code`, `error_code`, `message`, `response_id`.
- HTTP-запросы теперь отправляются через специальную обёртку — `TimewebCloud._request()`. Это позволило сделать универсальный обработчик исключений и упростить работу с запросами и логирование.

## Исправлено

- Программа больше не падает, если у облачного сервера нет публичных IP-адресов.
- В API-клиенте не было обработки кода подтверждения при удалении облачного сервера.
- При вызове метода для получения списка выделенных серверов аккаунта выводился список баз данных.
- Исправлены ошибки валидации данных при создании сервера, которые проявлялись в редких сценариях.

# Версия 1.3.1 (2023.04.13)

## Изменено

- В команде `twc s3 mb` опция `--preset-id` теперь необязательная. Будет выбран минимальный пресет.

## Исправлено

- Исправлена ошибка при попытке создать дополнительный профиль через `twc config`.

# Версия 1.3.0 (2023.04.13)

## Добавлено

- Добавлена команда `twc storage` (алиас `twc s3`) для управления бакетами в объектном хранилище Timeweb Cloud. Доступны базовые операции с бакетами. Также реализованы субкоманды для работы с доменами и пользователями хранилища. Обратите внимание, что в twc не планируется добавлять реализацию S3-клиента, пользуйтесь любым совместимым клиентом, например, [s3cmd](https://s3tools.org/s3cmd) или [rclone](https://rclone.org/), команда `twc s3 genconfig` позволит сгенерировать конфигурационный файл для этих утилит (см. [документацию](docs/ru/README.md#получение-конфигурации-для-s3-клиентов)).
- Добавлены субкоманды для `twc config`. Теперь можно: сделать дамп настроек CLI (`twc config dump`), изменять настройки без ручного редактирования файла (`twc config set`), получить путь до файла (`twc config file`), открыть файл в редакторе по умолчанию (`twc config edit`).

## Изменено

- Изменены тексты ошибок при работе с конфигурационным файлом, теперь они более наглядные и явно указывают на проблему.
- Изменено поведение команды `twc config`. Теперь если уже иммется конфигурационный файл команда предложит добавить новый профиль или отредактировать существующий.

# Версия 1.2.0 (2023.04.03)

## Добавлено

- Добавлена команда `twc database` (алиас `twc db`). Теперь можно:
    - создавать и удалять управляемые базы данных;
    - изменять параметры базы данных;
    - работать с бэкапами баз данных.
- Реализована возможность работы с токенами, которые требуют подтверждения удаления сервисов через проверочные коды.
- Добавлены алиасы для основных команд, набирать команды стало ещё быстрее. Например, `twc server list` можно сократить до `twc s ls`. Смотрите список алиасов во встроенной справке `--help`.
- Добавлены команды `twc server dash` и `twc server vnc`. С их помощью можно быстро перейти в дашборд и веб-консоль сервера соответсвенно. Ссылки откроются в браузере по умолчанию.

## Изменено

- Поменялся вывод команд `twc server list-presets` и `twc server backup list`, скрыты малоинформативные колонки.
- Мелкие улучшения в коде.

# Версия 1.1.0 (2023.03.24)

## Добавлено

- Добавлена команда `twc image` для управления образами дисков. Можно создавать образы из существующих дисков, загрузить свой образ по ссылке, удалять образы и выполнять другие базовые операции.
- Добавлена возможность использовать UUID пользовательского образа при создании нового сервера (`twc server create`) и при переустановке сервера (`twc server reinstall`).
- Добавлена команда `twc project` для управления проектами и ресурсами в них: создание, удаление, редактирование проектов, перемещение ресурсов между проектами.
- В команду `twc server create` добавлена опция `--project-id`, которая позволяет переместить только что созданный сервер в указанный проект. Задать проект можно также через переменную окружения `TWC_PROJECT` и конфигурационный файл.
- В команду `twc server reinstall` добавлена опция `--add-ssh-key`. Теперь опционально после переустановки на сервер будут добавлены SSH-ключи, которые были на нём ранее.
- Добавлена команда `twc server disk list-all`. Она покажет список всех дисков со всех серверов.
- Опция `--filter` в командах где она есть теперь поддерживает поиск по полям, содержащим значения в мегабайтах и гагибайтах.

## Изменено

- Команда `twc server reinstall` теперь не требует `--image` как обязательный аргумент. Если опция не задана будет выбрана ОС, которая уже установлена на сервере.
- В команде `twc server clone` теперь используется новый метод клонирования сервера. В ответ команда вернёт информацию о клоне сервера.
- В командах `twc server list` и `twc server logs` увеличен стандартный `--limit` до 500.
- В локации `pl-1` (Польша, Гданьск) теперь разрешено добавлять IPv6-адреса.
- В выводе `twc server list-presets` RAM и объём системного диска в табличном виде теперь отображаются в гигабайтах.

## Исправлено

- В выводе команды `twc server list-os-images` теперь правильно отображаем поле `REQUIREMENTS`.
- Исправлена ошибка из-за которой опция `--filter` не фильтровала по ключам, содержащим знак подчёркивания.

# Версия 1.0.0 (2023.02.27)

Первый релиз.
